      REAL FUNCTION sla_RANDOM (SEED)
*+
*     - - - - - - -
*      R A N D O M
*     - - - - - - -
*
*  Generate pseudo-random real number in the range 0 <= X < 1.
*  (single precision)
*
*  !!!  Version for Linux !!!
*
*  Given:
*     SEED     real     an arbitrary real number
*
*  Notes:
*
*  1)  The result is a pseudo-random REAL number in the range
*      0 <= sla_RANDOM < 1.
*
*  2)  SEED is used first time through only.
*
*  Called:  RANDOM (a REAL function compiled by the makefile from rtl_random.c)
*
*  B.K.McIlwrath Starlink   12 January 1996
*-

      IMPLICIT NONE

      REAL SEED

      REAL RANDOM

      REAL AS
      INTEGER ISEED
      LOGICAL FIRST
      SAVE FIRST
      DATA FIRST /.TRUE./



*  If first time, turn SEED into a large, odd integer
      IF (FIRST) THEN
         AS=ABS(SEED)+1.0
         ISEED=NINT(AS/10.0**(NINT(ALOG10(AS))-6))
         IF (MOD(ISEED,2).EQ.0) ISEED=ISEED+1
         FIRST=.FALSE.
      ELSE
         ISEED = 0
      END IF

*  Next pseudo-random number
      sla_RANDOM=RANDOM(ISEED)

      END

c---------------------------------------------------------------------------
c	Addition: uses NumRec random generator as defined here (taken from ran3.f) 
c
      FUNCTION random(idum)
      implicit none
      INTEGER idum
      INTEGER MBIG,MSEED,MZ
C     REAL MBIG,MSEED,MZ
      REAL random,FAC
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1./MBIG)
C     PARAMETER (MBIG=4000000.,MSEED=1618033.,MZ=0.,FAC=1./MBIG)
      INTEGER i,iff,ii,inext,inextp,k
      INTEGER mj,mk,ma(55)
C     REAL mj,mk,ma(55)
      SAVE iff,inext,inextp,ma
      DATA iff /0/
      if(idum.lt.0.or.iff.eq.0)then
        iff=1
        mj=MSEED-iabs(idum)
        mj=mod(mj,MBIG)
        ma(55)=mj
        mk=1
        do 11 i=1,54
          ii=mod(21*i,55)
          ma(ii)=mk
          mk=mj-mk
          if(mk.lt.MZ)mk=mk+MBIG
          mj=ma(ii)
11      continue
        do 13 k=1,4
          do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i).lt.MZ)ma(i)=ma(i)+MBIG
12        continue
13      continue
        inext=0
        inextp=31
        idum=1
      endif
      inext=inext+1
      if(inext.eq.56)inext=1
      inextp=inextp+1
      if(inextp.eq.56)inextp=1
      mj=ma(inext)-ma(inextp)
      if(mj.lt.MZ)mj=mj+MBIG
      ma(inext)=mj
      random=mj*FAC
      return
      END




